#python imports
from typing import Optional, List

#dependency imports
from use_cases import IProductRepository

class ProductDatabase(IProductRepository):
    def __init__(self):
        # Mock database setup
        self.mock_db = {
            1: {"id": 1, "name": "Apple", "description": "gsdg", "price": 0.5},
            2: {"id": 2, "name": "Bread", "description": "sfg", "price": 2.0},
        }

    def get_product_by_id(self, product_id: int) -> Optional[List[dict]]:
        return self.mock_db.get(product_id)
